import { type ButtonVariants } from '.';
import { type HTMLAttributes } from 'vue';
type IconProps = {
    position?: 'left' | 'right';
    description?: string;
};
type BaseButtonProps = {
    variant: ButtonVariants['variant'];
    href?: string | null;
    target?: string;
    buttonAction?: 'submit' | 'reset' | 'button';
    isDisabled?: boolean;
    isLoading?: boolean;
    class?: HTMLAttributes['class'];
    icon?: IconProps | null;
};
type IconOnlyButtonProps = BaseButtonProps & {
    buttonType: 'icon';
    buttonSize: Exclude<ButtonVariants['size'], 'large'>;
};
type TextButtonProps = BaseButtonProps & {
    buttonType: 'button';
    buttonSize: ButtonVariants['size'];
};
export type ButtonProps = IconOnlyButtonProps | TextButtonProps;
declare function __VLS_template(): {
    attrs: Partial<{}>;
    slots: Readonly<{
        /** The icon component to render */
        icon(): any;
        /** The content for the button */
        default(): any;
    }> & {
        /** The icon component to render */
        icon(): any;
        /** The content for the button */
        default(): any;
    };
    refs: {};
    rootEl: any;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: import("vue").DefineSetupFnComponent<Record<string, any>, {}, {}, Record<string, any> & {}, import("vue").PublicProps>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
